/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.9 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 16.12.2010
Author  : Admin
Company : Microsoft
Comments: 


Chip type               : ATmega32
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 512
*****************************************************/

#include <mega32.h>
#include <stdio.h>
#include <delay.h>
#include <1100.h>
#include <ds18b20.h>
#asm  
  .equ __w1_port=0x1B; PORTA
  .equ __w1_bit=0 
#endasm

int temper;                //    
unsigned char devices;     //     
unsigned char LcdBuffDevices[20];
unsigned char RomCode[2][9];
unsigned char LcdBuff1[20];
unsigned char LcdBuff2[20];

//#pragma rl+
char *str1=":";
char *str2="!";
//#pragma rl-


// Timer 1 output compare A interrupt service routine
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
// Place your code here
  TCNT1H=0;
  TCNT1L=0;
  //sek++;  
}
//-------------------------------
// Declare your global variables here

void main(void)
{
 
PORTA=0x00;
DDRA=0x00;

PORTB=0x00;
DDRB=0x0F;
 
PORTC=0x00;
DDRC=0x00;
 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x05;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x1E;
OCR1AL=0x85;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x10;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

lcd_init();
delay_ms(30);
lcd_clear();
delay_ms(30);

// 
//line(0,40,40,40);   
  devices=w1_search( DS18B20_SEARCH_ROM_CMD, RomCode ); //    1-wire
   
  if( devices )
  {
    sprintf( LcdBuffDevices,"DS18B20=%u", devices ); //   - 
    
    gotoxy( 0,1 ); print_string( LcdBuffDevices ); gotoxy( 0,0 ); print_string( str1 );
   
    ds18b20_init( &RomCode[0][0], 30, 60, DS18B20_12BIT_RES ); //  
    ds18b20_init( &RomCode[1][0], 30, 60, DS18B20_12BIT_RES ); //  
  line(10,40,45,5);
  while( 1 )
  {
    //   
    sprintf( LcdBuff1,"t1=%.1f\'C", ds18b20_temperature( &RomCode[0][0] ) );
  
    gotoxy( 0,2 ); print_string( LcdBuff1 );
   
    //   
    sprintf( LcdBuff2,"t2=%.1f\'C", ds18b20_temperature( &RomCode[1][0] ) );
  
    gotoxy( 0,3 ); print_string( LcdBuff2 ); }
   
  }else{ gotoxy( 0,0 ); print_string( str2 ); }
}